#if !defined(AFX_MEMORYWATCH_H__AC3EAF53_9122_11D1_BF13_0000C0EB65E5__INCLUDED_)
#define AFX_MEMORYWATCH_H__AC3EAF53_9122_11D1_BF13_0000C0EB65E5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// MemoryWatch.h : header file
//

#include "../emu/hc11.h"
#include "../emu/list.h"

//////////////////////////////////////////////////////////////////////////////
//
// Class Name: CMemoryWatch
//
// Author: Kalle Anderson
//
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CMemoryWatch dialog

class CMemoryWatch : public CDialog
{
// Construction
    // Check to see if it should be updated
    bool visible;
    
    // pointer to the hc11
    HC11 *hc11;
public:
	CMemoryWatch(HC11 *hc11, CWnd* pParent = NULL);   // standard constructor
    // reread the values
    void Update(void);
    // list of the addresses
    list<word_t> watches;
    enum {hex_base,decimal_base,binary_base} numerical_base;
    
    // Hide or show this window
    void Visible(bool val);
    bool Visible(void){return visible;};    

    // Add a watch
    void AddWatch(CString name, word_t address);
    // Clear them all
    void ClearWatches(void);

// Dialog Data
	//{{AFX_DATA(CMemoryWatch)
	enum { IDD = IDD_MEMWATCH };
	CButton	m_delete;
	CButton	m_add;
	CListCtrl	m_listctrl;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMemoryWatch)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMemoryWatch)
	afx_msg void OnAddwatch();
	afx_msg void OnDeletewatch();
	afx_msg void OnUpdate();
	virtual void OnOK();
	afx_msg void OnModify();
	afx_msg void OnBase();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//////////////////////////////////////////////////////////////////////////////
//
// Class Name: CRegisterWatch
//
// Author: Kalle Anderson
//
// Purpose: A static memory watch containing just registers.
//
/////////////////////////////////////////////////////////////////////////////
class CRegisterWatch: public CMemoryWatch 
{
    public:
        CRegisterWatch(HC11 *hc11, CWnd* pParent = NULL);               
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MEMORYWATCH_H__AC3EAF53_9122_11D1_BF13_0000C0EB65E5__INCLUDED_)
